
package de.ivu.elect.presentation.email;

import de.ivu.elect.business.email.control.EmailSendenEvent;
import de.ivu.elect.business.email.entity.EmailVorgang;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.jee.background.NotifyOnSuccess;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.email.form.EmailVorgangViewFormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

import javax.inject.Inject;
import javax.inject.Named;

@Named(AbstractEmailVorgangEditView.COMPONENT_NAME)
@OnlineHilfeId(value = "743", mehrfachVergebenOk = true)
public class EmailVorgangEditView extends AbstractEmailVorgangEditView {

  private static final long serialVersionUID = 1L;

  @Inject
  private EmailVorgangViewFormBuilder emailVorgangViewFormBuilder;

  public EmailVorgangEditView() {
    super();
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return false;
  }

  @Override
  public void addProperties(FormBuilder formBuilder, EmailVorgang emailVorgang) {
    emailVorgangViewFormBuilder.addEmailVorgangProperties(formBuilder, emailVorgang);
  }

  @NotifyOnSuccess(EmailSendenEvent.class)
  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORGANG_EDIT)
  public String sendeAlleEmailsErneut() {
    edit.sendeAlleEmailsErneut(getEntity());

    addInfoMessage("email.vorgang.edit.action.sende.alle.erneut.success.message", getMessage("EmailStatusType.ZU_VERSENDEN"));

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }

  @NotifyOnSuccess(EmailSendenEvent.class)
  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORGANG_EDIT)
  public String sendeFehlerhafteEmailsErneut() {
    edit.sendeFehlerhafteEmailsErneut(getEntity());

    addInfoMessage("email.vorgang.edit.action.sende.fehlerhafte.erneut.success.message", getMessage("EmailStatusType.ZU_VERSENDEN"));

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORGANG_EDIT)
  public String sendenAbbrechen() {
    edit.sendenAbbrechen(getEntity());

    addInfoMessage("email.vorgang.edit.action.senden.abbrechen.success.message", getMessage("EmailStatusType.FEHLER"));

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }
}
